KUBERNETES(1)(kubernetes)

Eric Paris Jan 2015

NAME

kubectl expose - Take a replication controller, service, deployment or pod and expose it as a new Kubernetes service

SYNOPSIS

kubectl expose [OPTIONS]

DESCRIPTION

Expose a resource as a new Kubernetes service.

Looks up a deployment, service, replica set, replication controller or pod by name and uses the selector for that resource as the selector for a new service on the specified port. A deployment or replica set will be exposed as a service only if its selector is convertible to a selector that service supports, i.e. when the selector contains only the matchLabels component. Note that if no port is specified via --port and the exposed resource has multiple ports, all will be re-used by the new service. Also if no labels are specified, the new service will re-use the labels from the resource it exposes.

Possible resources include (case insensitive):

pod (po), service (svc), replicationcontroller (rc), deployment (deploy), replicaset (rs)

OPTIONS

--allow-missing-template-keys=true
    If true, ignore any errors in templates when a field or map key is missing in the template. Only applies to golang and jsonpath output formats.

--cluster-ip=""
    ClusterIP to be assigned to the service. Leave empty to auto-allocate, or set to 'None' to create a headless service.

--dry-run="none"
    Must be "none", "server", or "client". If client strategy, only print the object that would be sent, without sending it. If server strategy, submit server-side request without persisting the resource.

--external-ip=""
    Additional external IP address (not managed by Kubernetes) to accept for the service. If this IP is routed to a node, the service can be accessed by this IP in addition to its generated service IP.

--field-manager="kubectl-expose"
    Name of the manager used to track field ownership.

-f, --filename=[]
    Filename, directory, or URL to files identifying the resource to expose a service

-k, --kustomize=""
    Process the kustomization directory. This flag can't be used together with -f or -R.

-l, --labels=""
    Labels to apply to the service created by this call.

--load-balancer-ip=""
    IP to assign to the LoadBalancer. If empty, an ephemeral IP will be created and used (cloud-provider specific).

--name=""
    The name for the newly created object.

-o, --output=""
    Output format. One of: (json, yaml, name, go-template, go-template-file, template, templatefile, jsonpath, jsonpath-as-json, jsonpath-file).

--override-type="merge"
    The method used to override the generated object: json, merge, or strategic.

--overrides=""
    An inline JSON override for the generated object. If this is non-empty, it is used to override the generated object. Requires that the object supply a valid apiVersion field.

--port=""
    The port that the service should serve on. Copied from the resource being exposed, if unspecified

--protocol=""
    The network protocol for the service to be created. Default is 'TCP'.

--record=false
    Record current kubectl command in the resource annotation. If set to false, do not record the command. If set to true, record the command. If not set, default to updating the existing annotation value only if one already exists.

-R, --recursive=false
    Process the directory used in -f, --filename recursively. Useful when you want to manage related manifests organized within the same directory.

--save-config=false
    If true, the configuration of current object will be saved in its annotation. Otherwise, the annotation will be unchanged. This flag is useful when you want to perform kubectl apply on this object in the future.

--selector=""
    A label selector to use for this service. Only equality-based selector requirements are supported. If empty (the default) infer the selector from the replication controller or replica set.)

--session-affinity=""
    If non-empty, set the session affinity for the service to this; legal values: 'None', 'ClientIP'

--show-managed-fields=false
    If true, keep the managedFields when printing objects in JSON or YAML format.

--target-port=""
    Name or number for the port on the container that the service should direct traffic to. Optional.

--template=""
    Template string or path to template file to use when -o=go-template, -o=go-template-file. The template format is golang templates [http://golang.org/pkg/text/template/#pkg-overview].

--type=""
    Type for this service: ClusterIP, NodePort, LoadBalancer, or ExternalName. Default is 'ClusterIP'.

OPTIONS INHERITED FROM PARENT COMMANDS

--as=""
    Username to impersonate for the operation. User could be a regular user or a service account in a namespace.

--as-group=[]
    Group to impersonate for the operation, this flag can be repeated to specify multiple groups.

--as-uid=""
    UID to impersonate for the operation.

--cache-dir="/home/username/.kube/cache"
    Default cache directory

--certificate-authority=""
    Path to a cert file for the certificate authority

--client-certificate=""
    Path to a client certificate file for TLS

--client-key=""
    Path to a client key file for TLS

--cluster=""
    The name of the kubeconfig cluster to use

--context=""
    The name of the kubeconfig context to use

--disable-compression=false
    If true, opt-out of response compression for all requests to the server

--insecure-skip-tls-verify=false
    If true, the server's certificate will not be checked for validity. This will make your HTTPS connections insecure

--kubeconfig=""
    Path to the kubeconfig file to use for CLI requests.

--match-server-version=false
    Require server version to match client version

-n, --namespace=""
    If present, the namespace scope for this CLI request

--password=""
    Password for basic authentication to the API server

--profile="none"
    Name of profile to capture. One of (none|cpu|heap|goroutine|threadcreate|block|mutex)

--profile-output="profile.pprof"
    Name of the file to write the profile to

--request-timeout="0"
    The length of time to wait before giving up on a single server request. Non-zero values should contain a corresponding time unit (e.g. 1s, 2m, 3h). A value of zero means don't timeout requests.

-s, --server=""
    The address and port of the Kubernetes API server

--tls-server-name=""
    Server name to use for server certificate validation. If it is not provided, the hostname used to contact the server is used

--token=""
    Bearer token for authentication to the API server

--user=""
    The name of the kubeconfig user to use

--username=""
    Username for basic authentication to the API server

--version=false
    --version, --version=raw prints version information and quits; --version=vX.Y.Z... sets the reported version

--warnings-as-errors=false
    Treat warnings received from the server as errors and exit with a non-zero exit code

EXAMPLE
      # Create a service for a replicated nginx, which serves on port 80 and connects to the containers on port 8000
      kubectl expose rc nginx --port=80 --target-port=8000

      # Create a service for a replication controller identified by type and name specified in "nginx-controller.yaml", which serves on port 80 and connects to the containers on port 8000
      kubectl expose -f nginx-controller.yaml --port=80 --target-port=8000

      # Create a service for a pod valid-pod, which serves on port 444 with the name "frontend"
      kubectl expose pod valid-pod --port=444 --name=frontend

      # Create a second service based on the above service, exposing the container port 8443 as port 443 with the name "nginx-https"
      kubectl expose service nginx --port=443 --target-port=8443 --name=nginx-https

      # Create a service for a replicated streaming application on port 4100 balancing UDP traffic and named 'video-stream'.
      kubectl expose rc streamer --port=4100 --protocol=UDP --name=video-stream

      # Create a service for a replicated nginx using replica set, which serves on port 80 and connects to the containers on port 8000
      kubectl expose rs nginx --port=80 --target-port=8000

      # Create a service for an nginx deployment, which serves on port 80 and connects to the containers on port 8000
      kubectl expose deployment nginx --port=80 --target-port=8000

SEE ALSO

kubectl(1),

HISTORY

January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!